<template>
    <AdminMenuBar>
        <el-tabs type="border-card" v-model="mainTabActive" @tab-change="handleTabClick" stretch>
            <el-tab-pane name="first">
                <template #label>
                    <div v-if="mainTabActive == 'first'" class="flex items-center gap-sm">
                        <el-icon>
                            <Avatar />
                        </el-icon>
                        <h1>Administrators</h1>
                    </div>
                    <p v-else>Administrators</p>
                </template>
                <el-tooltip content="Refresh" placement="bottom" effect="dark">
                        <el-button @click="getAdminData" size="large">
                            <el-icon>
                                <RefreshRight />
                            </el-icon>
                        </el-button>
                    </el-tooltip>
                <el-table :data="data" size="large" fit stripe lazy load v-loading="loading">
                    <el-table-column prop="name" label="Name" align="center" />
                    <el-table-column prop="email" label="Email" align="center" />
                    <el-table-column align="center">
                        <template #default="{ row }">
                            <el-button type="danger" @click="removeAdmin(row.id)">REMOVE ADMIN</el-button>
                        </template>
                    </el-table-column>
                </el-table>
            </el-tab-pane>
            <el-tab-pane name="second">
                <template #label>
                    <div v-if="mainTabActive == 'second'" class="flex items-center gap-sm">
                        <el-icon>
                            <Management />
                        </el-icon>
                        <h1>Add Administrator</h1>
                    </div>
                    <p v-else>Add Administrator</p>
                </template>
                <div class="flex items-center items-justify">
                    <el-card v-loading="loading" class="login-card padding-md">
                        <h1>Add Administrator</h1>
                        <el-form ref="formRef" :model="form" :size="formSize" :rules="rules">
                            <el-form-item v-for="item in formItems" :prop="item.id">
                                <el-input :class="item.class" :type="item.type" :id="item.id" v-model="form[item.id]"
                                    :placeholder="`${item.id.charAt(0).toUpperCase()}${item.id.slice(1)}`"
                                    :show-password="item.type == 'password'" />
                            </el-form-item>
                            <el-form-item class="">
                                <el-button @click="register">Create</el-button>
                                <el-button @click="resetForm">Reset</el-button>
                            </el-form-item>
                            <el-form-item>

                            </el-form-item>
                        </el-form>
                    </el-card>
                </div>
            </el-tab-pane>

            <!-- <el-tab-pane name="third">
                <template #label>
                    <div v-if="mainTabActive == 'third'" class="flex items-center gap-sm">
                        <el-icon>
                            <Management />
                        </el-icon>
                        <h1>System Settings</h1>
                    </div>
                    <p v-else>System Settings</p>
                </template>
                <el-card>
                    <el-form-item label="Shipping Fee">
                        <el-input-number size="large"/>
                    </el-form-item>
                 
                    <el-button type="danger">Save Option</el-button>
                </el-card>
            </el-tab-pane> -->
        </el-tabs>
    </AdminMenuBar>
</template>

<style scoped>
.login-card {
    width: 400px;
    max-width: 90%;
}
</style>


<script setup>
import { ref, onMounted, onBeforeUnmount } from "vue"
import { useRouter } from 'vue-router';
import adminHelper from "../helpers/adminHandler"
import formHelper from "../helpers/form"
import { ElMessageBox } from "element-plus";
import { Avatar, Management, RefreshRight } from "@element-plus/icons-vue";

const router = useRouter();
const { formSize, formRef, form, resetForm, rules } = formHelper
const { performRequest } = adminHelper

const loading = ref(false);
const data = ref([]);

const mainTabActive = ref('first');

const handleTabClick = () => {
    if (mainTabActive.value == 'first') {
        getAdminData();
    }
}

const formItems = ref(
    [
        {
            'id': 'name',
            'type': 'name'
        },
        {
            'id': 'email',
            'type': 'email'
        },
        {
            'id': 'password',
            'type': 'password'
        },
        {
            id: "password_confirmation",
            placeholder: "Confirm Password",
            type: "password",
            rule: [rules.password_confirmation],
        },
    ]
)
const register = async () => {
    const URL_registerAdmin = "/api/admin/register";
    const payloadProperties = ['name', 'email', 'password', 'password_confirmation'];
    const requestType = 'register'

    ElMessageBox.confirm(
        "Are you sure you want to add this new administrator?",
        "Warning",
        {
            cancelButtonText: "Cancel",
            confirmButtonText: "Confirm",
            type: "warning",
        }
    ).then(async () => {
        loading.value = true;
        await performRequest(URL_registerAdmin, payloadProperties, requestType, router);
    })
        .catch((error) => {
            console.log(error);
        }).finally(() => {
            loading.value = false;
            resetForm();
        });

};

const getAdminData = async () => {
    const getAdmins_URL = '/api/admin/getAdmins'
    try {
        loading.value = true;

        const headers = { Authorization: `Bearer ${localStorage.getItem("admin_token") ?? sessionStorage.getItem("admin_token")}` };
        const response = await axios({
            method: 'GET',
            url: getAdmins_URL,
            headers: headers,
        });

        data.value = response.data;


        console.log(response);
    } catch (error) {
        data.value = [];
        console.log(error);
        loading.value = false;
    } finally {
        loading.value = false;
    }
};

const removeAdmin = async (id) => {

    ElMessageBox.confirm(
        "Are you sure you want to add delete this administrator?",
        "Warning",
        {
            cancelButtonText: "Cancel",
            confirmButtonText: "Confirm",
            type: "warning",
        }
    ).then(async () => {
        loading.value = true;
        let adminData = {
            "id": id
        };
        let token = localStorage.getItem("admin_token") ?? sessionStorage.getItem("admin_token");
        const headers = {
            Authorization: `Bearer ${token}`,
        };
        await axios({
            method: "POST",
            url: "/api/admin/destroyAdmin",
            data: adminData,
            headers: headers,
        });
        getAdminData();
    })
        .catch((error) => {
            console.log(error);
        }).finally(() => {
            loading.value = false;
        });

}

const handleLogin = (event) => {
    if (event.keyCode === 13) {
        event.preventDefault();
        login();
    }
};
onMounted(() => {
    document.body.addEventListener('keydown', handleLogin);
    getAdminData();
})
onBeforeUnmount(() => {
    document.body.removeEventListener('keydown', handleLogin);
})
</script>
